#include <R.h>
#include <Rinternals.h>
#include <R_ext/Lapack.h>
#include <R_ext/BLAS.h>

extern "C" {
  
  //sparsekit
  void F77_NAME(aplb)(int *nrow, int *ncol, int *job, double *a, int *ja, int *ia, 
		      double *b, int *jb, int *ib,
		      double *c, int *jc, int *ic, int *nzmax, int *iw, int *ierr);

  void F77_NAME(csrdns)(int *nrow, int *ncol,
			double *a, int *ja, int *ia,
			double *dns, int *ndns, int *ierr);
}


void show(double *a, int r, int c){

  for(int i = 0; i < r; i++){
    
    for(int j = 0; j < c; j++){

      Rprintf("%.5f\t",a[j*r+i]);

    }

    Rprintf("\n");
  }
  
}


void show(int n, int p, double *x, int *j_x, int *i_x){
  
  int ierr;
  
  double *D = new double[n*p];
    
  csrdns_(&n, &p, x, j_x, i_x, D, &n, &ierr); if(ierr != 0){error("csrdns in show failed\n");}

  show(D, n, p);
  
  delete D;
  
}

extern "C" {

  SEXP Q(){

    //(0    5.0  0)
    //(1.0  0    2.0)
    //(3.0  0    0)
    //(0    0    9.0)

    int n = 4;
    int p = 3;
    
    int nnz_a = 5;
    double *a = (double *) R_alloc(nnz_a, sizeof(double)); //non-zero elements
    int *j_a = (int *) R_alloc(nnz_a, sizeof(int)); //column indea
    int *i_a = (int *) R_alloc(n+1, sizeof(int)); //row ptr
    
    a[0] = 5.0; a[1] = 1.0; a[2] = 2.0; a[3] = 3.0; a[4] = 9.0;
    j_a[0] = 2; j_a[1] = 1; j_a[2] = 3; j_a[3] = 1; j_a[4] = 3;
    i_a[0] = 1; i_a[1] = 2; i_a[2] = 4; i_a[3] = 5; i_a[4] = i_a[0]+nnz_a;
    
    int nnz_b = 5;
    double *b = (double *) R_alloc(nnz_b, sizeof(double)); //non-zero elements
    int *j_b = (int *) R_alloc(nnz_b, sizeof(int)); //column indea
    int *i_b = (int *) R_alloc(n+1, sizeof(int)); //row ptr
    
    b[0] = 5.0; b[1] = 1.0; b[2] = 2.0; b[3] = 3.0; b[4] = 9.0;
    j_b[0] = 2; j_b[1] = 1; j_b[2] = 3; j_b[3] = 1; j_b[4] = 3;
    i_b[0] = 1; i_b[1] = 2; i_b[2] = 4; i_b[3] = 5; i_b[4] = i_b[0]+nnz_b;
    
    int nnz_c = n*p;
    double *c = (double *) R_alloc(nnz_c, sizeof(double)); //non-zero elements
    int *j_c = (int *) R_alloc(nnz_c, sizeof(int)); //column indea
    int *i_c = (int *) R_alloc(n+1, sizeof(int)); //row ptr
    
    int job1 = 1;
    int ierr;
    int *iw = (int *) R_alloc(n, sizeof(int));
    
    F77_NAME(aplb)(&n, &p, &job1, a, j_a, i_a, 
		   b, j_b, i_b,
		   c, j_c, i_c, &nnz_c, iw, &ierr); if(ierr != 0){error("aplb in main failed\n");}

    show(n, p, c, j_c, i_c);
    
   return R_NilValue;
 }
}
